LeetCode 377 Combination Sum IV

来源:互联网 发布:windows哪个系统好用 编辑:程序博客网 时间:2024/06/11 13:27

Given an integer array with all positive numbers and no duplicates, find the number of possible combinations that add up to a positive integer target.
Example:
nums = [1, 2, 3]
target = 4
The possible combination ways are:
(1, 1, 1, 1)
(1, 1, 2)
(1, 2, 1)
(1, 3)
(2, 1, 1)
(2, 2)
(3, 1)
Note that different sequences are counted as different combinations.
Therefore the output is 7.
给定一个数组,里边都是正数,而且没有重复的。再给你个target作为目标数。从之前的数组中取若干数,和为target,数组中的数可以重复用,注意不同次序的答案算不同,比如(1,1,2)和(1,2,1)算不同答案。
这个题最开始我想到了线性代数中的线性方程求解==好吧,这样很难做出来。再看看,其实这个题有点像爬楼梯那道题(http://hilbert25.applinzi.com/index.php/2017/03/10/climbing-stairs/),比如nums=[1,2,3],target=4,我们可以理解为一次可以上1个台阶2个台阶3个台阶,一共4个台阶,问多少解法?
如果这个题用递归,也不是不行,就是太麻烦了。那么我们可以用dp。假设走i个台阶的走法有dp[i]种,那么他的上一步可以走nums[0]步,nums[1]步……于是可得:
dp[i]=dp[i-nums[0]]+dp[i-num[1]]+dp[i-nums[2]]……
代码如下:

12345678910111213141516171819
   public static int combinationSum4(int[] nums, int target) {        if (nums.length == 0) {            if (target == 0)                return 1;            else                return 0;        }        Arrays.sort(nums);        if(nums[0]>target)            return 0;//最小的数比目标数还大就返回0,        int[] record = new int[target + 1];        record[0] = 1;        for (int i = nums[0]; i < = target; i++) {            for (int j = 0; j < nums.length && nums[j] <= i; j++) {                record[i] += record[i - nums[j]];            }        }        return record[target];    }

最后解释下我为什么要先排序?
1 方便找到最小的数,这个代码注释中说明了
2 由于从第0步开始逐步变大,因此从最小步长开始一直到最大步长(target),方便跳过太大的步长。

原创粉丝点击